/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { Series } from "./Series";
import { NumericXAxis } from "./NumericXAxis";
import { DependencyProperty } from "igniteui-react-core/ES5/DependencyProperty";
import { NumericYAxis } from "./NumericYAxis";
import { Color } from "igniteui-react-core/ES5/Color";
import { ScatterFrame } from "./ScatterFrame";
import { KDTree2D } from "./KDTree2D";
import { Type, typeGetValue, runOn, delegateRemove, typeCast, delegateCombine, markType, Nullable$1 } from "igniteui-react-core/ES5/type";
import { Rect } from "igniteui-react-core/ES5/Rect";
import { IFastItemsSource_$type } from "igniteui-react-core/ES5/IFastItemsSource";
import { SeriesView } from "./SeriesView";
import { List$1 } from "igniteui-react-core/ES5/List$1";
import { KDPointData } from "./KDPointData";
import { ScalerParams } from "./ScalerParams";
import { ProgressiveLoadStatusEventArgs } from "./ProgressiveLoadStatusEventArgs";
import { SearchArgs } from "./SearchArgs";
import { KDTreeNode2D } from "./KDTreeNode2D";
import { AxisRange } from "./AxisRange";
import { PropertyMetadata } from "igniteui-react-core/ES5/PropertyMetadata";
import { truncate, isNaN_, isInfinity, logBase, intDivide } from "igniteui-react-core/ES5/number";
import { boxArray$1, arrayShallowClone } from "igniteui-react-core/ES5/array";
import { dateNow } from "igniteui-react-core/ES5/date";
import { RenderingContext } from "igniteui-react-core/ES5/RenderingContext";
import { CanvasViewRenderer } from "igniteui-react-core/ES5/CanvasViewRenderer";
import { Rectangle } from "igniteui-react-core/ES5/Rectangle";
var HighDensityScatterSeries = /** @class */ (function (_super) {
    tslib_1.__extends(HighDensityScatterSeries, _super);
    function HighDensityScatterSeries() {
        var _this = _super.call(this) || this;
        _this.l4 = null;
        _this.l6 = null;
        _this.nc = 0;
        _this.l8 = false;
        _this.ms = 0;
        _this.mr = 0;
        _this.mq = 0;
        _this.mp = 255;
        _this.mo = 0;
        _this.mn = 0;
        _this.mv = 255;
        _this.mu = 0;
        _this.mt = 0;
        _this.lw = null;
        _this.l1 = null;
        _this.l2 = null;
        _this.lx = null;
        _this.lz = null;
        _this.ma = false;
        _this.nd = 0;
        _this.nf = 0;
        _this.m9 = 0;
        _this.m8 = 0;
        _this.progressiveLoadStatusChanged = null;
        _this.mf = null;
        _this.ml = 0;
        _this.mk = 0;
        _this.mm = 0;
        _this.my = 0;
        _this.mw = 0;
        _this.mx = 0;
        _this.mz = 0;
        _this.m1 = 0;
        _this.m3 = 0;
        _this.m2 = 0;
        _this.m0 = 0;
        _this.mh = 0;
        _this.mi = 0;
        _this.mj = 0;
        _this.mg = 0;
        _this.nb = 0;
        _this.na = 0;
        _this.lt = null;
        _this.ne = 0;
        _this.l9 = false;
        _this._itemIndexes = null;
        _this.lu = null;
        _this.lr = null;
        _this.l3 = null;
        _this.ab = HighDensityScatterSeries.$;
        _this.c5 = false;
        return _this;
    }
    HighDensityScatterSeries.prototype.get_c4 = function () {
        return true;
    };
    Object.defineProperty(HighDensityScatterSeries.prototype, "l5", {
        get: function () {
            return this.l4;
        },
        set: function (a) {
            if (this.l4 != a) {
                var b = this.l5;
                this.l4 = a;
                this.raisePropertyChanged("XColumn", b, this.l5);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(HighDensityScatterSeries.prototype, "l7", {
        get: function () {
            return this.l6;
        },
        set: function (a) {
            if (this.l6 != a) {
                var b = this.l7;
                this.l6 = a;
                this.raisePropertyChanged("YColumn", b, this.l7);
            }
        },
        enumerable: true,
        configurable: true
    });
    HighDensityScatterSeries.prototype.oc = function () {
        if (this.lw == null) {
            return;
        }
        this.lw.s();
        var a = this.lw;
        a.progressiveThunkCompleted = delegateRemove(a.progressiveThunkCompleted, runOn(this, this.n0));
        this.lw = null;
    };
    HighDensityScatterSeries.prototype.ir = function (a, b, c, d) {
        _super.prototype.ir.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                if (this.bs != null) {
                    var e = this.getEffectiveViewport1(this.bi);
                    this.l9 = !e.isEmpty;
                }
                break;
            case "FastItemsSource":
                this.oc();
                if (typeCast(IFastItemsSource_$type, c) != null) {
                    c.deregisterColumn(this.l5);
                    c.deregisterColumn(this.l7);
                    this.l5 = null;
                    this.l7 = null;
                }
                if (typeCast(IFastItemsSource_$type, d) != null) {
                    this.l5 = this.bw(this.nu);
                    this.l7 = this.bw(this.ny);
                }
                if ((this.l0 != null && !this.l0.ck()) || (this.ly != null && !this.ly.ck())) {
                    this.i4(false);
                }
                this.ic();
                break;
            case HighDensityScatterSeries.$$p[7]:
                var f = this.lx;
                this.lx = this.ly;
                this.oc();
                if (f != null) {
                    f.rangeChanged = delegateRemove(f.rangeChanged, runOn(this, this.n3));
                }
                if (this.lx != null) {
                    var g = this.lx;
                    g.rangeChanged = delegateCombine(g.rangeChanged, runOn(this, this.n3));
                }
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ch(this);
                }
                if ((this.ly != null && !this.ly.ck()) || (d == null && c != null)) {
                    this.i4(false);
                }
                break;
            case HighDensityScatterSeries.$$p[9]:
                var h = this.lz;
                this.lz = this.l0;
                this.oc();
                if (h != null) {
                    h.rangeChanged = delegateRemove(h.rangeChanged, runOn(this, this.n3));
                }
                if (this.lz != null) {
                    var i = this.lz;
                    i.rangeChanged = delegateCombine(i.rangeChanged, runOn(this, this.n3));
                }
                if (c != null) {
                    c.bv(this);
                }
                if (d != null) {
                    d.ch(this);
                }
                if ((this.l0 != null && !this.l0.ck()) || (d == null && c != null)) {
                    this.i4(false);
                }
                break;
            case "MouseOverEnabled":
                this.ma = this.c5;
                this.i4(false);
                break;
            case HighDensityScatterSeries.$$p[8]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.l5);
                    this.l5 = this.bw(this.nu);
                }
                break;
            case "XColumn":
                this.oc();
                if (this.ly != null && !this.ly.ck()) {
                    this.i4(false);
                }
                this.ic();
                break;
            case HighDensityScatterSeries.$$p[10]:
                if (this.bz != null) {
                    this.bz.deregisterColumn(this.l7);
                    this.l7 = this.bw(this.ny);
                }
                break;
            case "YColumn":
                this.oc();
                if (this.l0 != null && !this.l0.ck()) {
                    this.i4(false);
                }
                this.ic();
                break;
            case HighDensityScatterSeries.$$p[6]:
                this.oc();
                this.i4(false);
                this.ib();
                break;
            case HighDensityScatterSeries.$$p[3]:
                this.i4(false);
                this.ib();
                break;
            case HighDensityScatterSeries.$$p[1]:
                this.i4(false);
                this.ib();
                break;
            case HighDensityScatterSeries.$$p[0]:
            case HighDensityScatterSeries.$$p[2]:
                if (!this.lv.by(this.or, this.oq)) {
                    return;
                }
                this.ms = this.or.o;
                this.mr = this.or.n;
                this.mq = this.or.m;
                this.mp = this.oq.o;
                this.mo = this.oq.n;
                this.mn = this.oq.m;
                this.mv = this.mp - this.ms;
                this.mu = this.mo - this.mr;
                this.mt = this.mn - this.mq;
                this.i4(false);
                this.ib();
                break;
            case HighDensityScatterSeries.$$p[4]:
                this.nc = Math.max(typeGetValue(d) - 1, 0);
                this.l8 = this.nc > 0;
                this.i4(false);
                this.ib();
                break;
            case HighDensityScatterSeries.$$p[5]:
                this.i4(false);
                this.ib();
                break;
        }
    };
    HighDensityScatterSeries.prototype.mc = function (a) {
        if (typeCast(NumericYAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    HighDensityScatterSeries.prototype.mb = function (a) {
        if (typeCast(NumericXAxis.$, a) !== null) {
            return true;
        }
        return false;
    };
    HighDensityScatterSeries.prototype.n3 = function (a, b) {
        this.oc();
        this.i4(false);
    };
    HighDensityScatterSeries.prototype.du = function (a, b, c) {
        var d = _super.prototype.du.call(this, a, b, c);
        if (this.l0 == null || this.ly == null || this.ly.bf == null || this.l0.bf == null || this.l7 == null || this.l5 == null || this.l7.count < 1 || this.l5.count < 1 || this.l7.count != this.l5.count || this.ly.jx == this.ly.jw || this.l0.jx == this.l0.jw || this.lp.isEmpty) {
            d = false;
        }
        return d;
    };
    Object.defineProperty(HighDensityScatterSeries.prototype, "nj", {
        get: function () {
            return this.nd;
        },
        set: function (a) {
            var b = this.nd;
            this.nd = a;
            this.raisePropertyChanged("ProgressiveStatus", b, this.nd);
        },
        enumerable: true,
        configurable: true
    });
    HighDensityScatterSeries.prototype.i5 = function (a) {
        _super.prototype.i5.call(this, a);
        this.n5(a, this.bi);
    };
    HighDensityScatterSeries.prototype.n5 = function (a, b) {
        if (this.cc(b)) {
            return;
        }
        if (this.lw == null && !this.me) {
            var c = new List$1(KDPointData.$, 2, this.l5.count);
            var d = this.ly;
            var e = this.l0;
            var f = new Rect(0, 0, 0, 1, 1);
            var g = new Rect(0, 0, 0, 1, 1);
            var h = new ScalerParams(1, f, g, d.b8);
            var i = new ScalerParams(1, f, g, e.b8);
            var j_1;
            var k_1;
            var _loop_1 = function (l) {
                j_1 = d.dt(this_1.l5.item(l), h);
                k_1 = e.dt(this_1.l7.item(l), i);
                if (!isNaN_(j_1) && !isNaN_(k_1) && !isInfinity(j_1) && !isInfinity(k_1)) {
                    c.add(((function () {
                        var $ret = new KDPointData();
                        $ret.a = j_1;
                        $ret.b = k_1;
                        $ret.c = l;
                        return $ret;
                    })()));
                }
            };
            var this_1 = this;
            for (var l = 0; l < this.l5.count; l++) {
                _loop_1(l);
            }
            if (this.md) {
                this.m8 = 1;
                this.m9 = truncate(logBase(c.count, 2)) + 3;
                this.nj = truncate(((this.m8 / this.m9) * 100));
                if (this.progressiveLoadStatusChanged != null) {
                    this.progressiveLoadStatusChanged(this, new ProgressiveLoadStatusEventArgs(this.nj));
                }
                this.lw = KDTree2D.b(c.toArray(), 1);
                var m = this.lw;
                m.progressiveThunkCompleted = delegateCombine(m.progressiveThunkCompleted, runOn(this, this.n0));
                if (!this.lw.f(this.e0)) {
                    var n = this.lw;
                    n.progressiveThunkCompleted = delegateRemove(n.progressiveThunkCompleted, runOn(this, this.n0));
                }
                this.ib();
            }
            else {
                var o = dateNow();
                this.lw = new KDTree2D(0, c.toArray(), 1);
                var p = dateNow();
            }
        }
        if (this.md && !this.me) {
            this.n6(b);
        }
        else {
            this.n7(b);
        }
    };
    HighDensityScatterSeries.prototype.hr = function (a, b, c, d) {
        _super.prototype.hr.call(this, a, b, c, d);
        this.oc();
        var e = false;
        if (this.ly != null && !this.ly.ck()) {
            e = true;
        }
        if (this.l0 != null && !this.l0.ck()) {
            e = true;
        }
        if (e) {
            this.i4(false);
        }
        this.ic();
    };
    HighDensityScatterSeries.prototype.n2 = function (a) {
        var b = a;
        var c = this.nb * this.na;
        if (this.ma) {
            if (this._itemIndexes == null || this._itemIndexes.length != c) {
                this._itemIndexes = new Array(c);
                for (var d = 0; d < c; d++) {
                    this._itemIndexes[d] = 0;
                }
            }
            else {
                for (var e = 0; e < c; e++) {
                    this._itemIndexes[e] = 0;
                }
            }
        }
    };
    HighDensityScatterSeries.prototype.n7 = function (a) {
        var b;
        var c;
        var d = null;
        if (a.n) {
            d = this._itemIndexes;
        }
        var e = a.getViewInfo(c, b);
        c = e.p0;
        b = e.p1;
        var f = a;
        var g = this.getEffectiveViewport1(a);
        this.l1 = new ScalerParams(0, b, c, this.lx.b8, g);
        this.l2 = new ScalerParams(0, b, c, this.lz.b8, g);
        this.n1(a);
        this.n2(a);
        var h = this.nb * this.na;
        if (this.lu == null || this.lu.length != h) {
            this.lu = new Array(h);
            this.lr = new Array(h);
        }
        var i = this.lu.length;
        var j = this.lu;
        var k = this.lr;
        for (var l = 0; l < i; l++) {
            j[l] = 0;
            k[l] = 0;
        }
        this.nf = truncate(Math.round(this.eq));
        this.lt = f.bv();
        var m = this.lt.length;
        var n = this.lt;
        for (var o = 0; o < m; o++) {
            n[o] = 0;
        }
        var p = this.m6;
        var q = this.m5;
        if (isNaN_(p) || isInfinity(p)) {
            p = 0;
        }
        if (isNaN_(q) || isInfinity(q)) {
            q = 50;
        }
        this.ml = Math.min(p, q);
        this.mk = Math.max(p, q);
        if (this.ml < 0) {
            this.ml = 0;
        }
        if (this.mk < 0) {
            this.mk = 0;
        }
        this.mm = this.mk - this.ml;
        if (this.me) {
            this.n4(a);
        }
        else {
            this.oe(a);
        }
        f.b6();
        if (a.n) {
            this._itemIndexes = d;
            this.lv.b7();
        }
    };
    HighDensityScatterSeries.prototype.n6 = function (a) {
        if (this.lw == null) {
            return;
        }
        this.n7(a);
    };
    HighDensityScatterSeries.prototype.n0 = function (a, b) {
        var _this = this;
        this.lv.b5(function () {
            if (_this.m8 < _this.m9 - 1) {
                _this.m8++;
            }
            _this.nj = truncate(((_this.m8 / _this.m9) * 100));
            if (_this.progressiveLoadStatusChanged != null) {
                _this.progressiveLoadStatusChanged(_this, new ProgressiveLoadStatusEventArgs(_this.nj));
            }
            _this.n6(_this.bi);
            _this.ib();
            if (_this.lw != null) {
                if (!_this.lw.f(_this.e0)) {
                    var c = _this.lw;
                    c.progressiveThunkCompleted = delegateRemove(c.progressiveThunkCompleted, runOn(_this, _this.n0));
                    _this.nj = 100;
                    if (_this.progressiveLoadStatusChanged != null) {
                        _this.progressiveLoadStatusChanged(_this, new ProgressiveLoadStatusEventArgs(_this.nj));
                    }
                }
            }
        });
    };
    HighDensityScatterSeries.prototype.n4 = function (a) {
        var b = arrayShallowClone(this.l5.asArray());
        this.ly.gh(boxArray$1(b), 0, b.length, this.l1);
        var c = arrayShallowClone(this.l7.asArray());
        this.ne = 0;
        var d = this.nc;
        var e = this.l8;
        var f = this.lu.length;
        this.l0.gh(boxArray$1(c), 0, c.length, this.l2);
        var g = 255 << 24 | truncate(this.ms) << 16 | truncate(this.mr) << 8 | truncate(this.mq);
        for (var h = 0; h < b.length; h++) {
            var i = truncate(b[h]);
            var j = truncate(c[h]);
            i = truncate(Math.floor(i));
            j = truncate(Math.floor(j));
            if (i < 0 || i >= this.nb || j < 0 || j >= this.na) {
                continue;
            }
            if (e) {
                var k = i - d;
                var l = i + d;
                l = l > (this.nb - 1) ? (this.nb - 1) : l;
                k = k < 0 ? 0 : k;
                var m = j + d;
                var n = j - d;
                for (var o = k; o <= l; o++) {
                    for (var p = n; p <= m; p++) {
                        var q = (p * this.nb) + o;
                        if (q < 0 || q > f - 1) {
                            continue;
                        }
                        this.lu[q] = this.lu[q] + 1;
                        this.lr[q] = 1;
                        this.ne++;
                        if (this.ma) {
                            this._itemIndexes[q] = h + 1;
                        }
                    }
                }
            }
            else {
                var r = (j * this.nb) + i;
                this.lu[r] = this.lu[r] + 1;
                this.lr[r] = 1;
                this.ne++;
                if (this.ma) {
                    this._itemIndexes[r] = h + 1;
                }
            }
        }
        this.n8();
    };
    HighDensityScatterSeries.prototype.oe = function (a) {
        var b;
        var c;
        var d = a.getViewInfo(b, c);
        b = d.p0;
        c = d.p1;
        if (this.lw == null) {
            return;
        }
        if (this.mf == null) {
            this.mf = new List$1(KDTreeNode2D.$, 2, truncate(Math.round(b.width * b.height)));
        }
        else {
            this.mf.clear();
        }
        var e = c.left;
        var f = c.right;
        var g = c.top;
        var h = c.bottom;
        this.m2 = c.top;
        this.m0 = c.height;
        this.m1 = c.left;
        this.m3 = c.width;
        this.my = b.top;
        this.mw = b.height;
        this.mx = b.left;
        this.mz = b.width;
        var i = this.getEffectiveViewport1(a);
        this.mh = (i.left - this.mx) / this.mz;
        this.mi = (i.top - this.my) / this.mw;
        var j = (i.right - this.mx) / this.mz;
        this.mj = j - this.mh;
        var k = (i.bottom - this.my) / this.mw;
        this.mg = k - this.mi;
        if (this.l9) {
            e = (e - this.mh) / this.mj;
            f = (f - this.mh) / this.mj;
            g = (g - this.mi) / this.mg;
            h = (h - this.mi) / this.mg;
        }
        var l = this.eq / b.width * c.width;
        var m = this.eq / b.height * c.height;
        var n = Math.min(l, m);
        var o = ((function () {
            var $ret = new SearchArgs();
            $ret.c = e;
            $ret.a = f;
            $ret.d = g;
            $ret.b = h;
            $ret.e = l;
            $ret.f = m;
            $ret.g = 0x7FFFFFFF;
            return $ret;
        })());
        this.lw.t(this.mf, o, 0, 1, 0, 1);
        var p;
        this.ne = 0;
        for (var q = 0; q < this.mf.count; q++) {
            p = this.mf._inner[q];
            this.n9(p);
        }
        this.n8();
    };
    HighDensityScatterSeries.prototype.n9 = function (a) {
        if (a.g) {
            return;
        }
        var b = a.e != null && a.e.a;
        var c = a.a == null ? 0 : a.a.length;
        var d = (a.h - c) + 1;
        if (b && d > 0) {
        }
        else {
            d = 1;
        }
        this.ob(a.b, d, b, a.e);
        if (c > 0 && !b) {
            var e = void 0;
            for (var f = 0; f < c; f++) {
                e = a.a[f];
                this.ob(e, d, false, a.e);
            }
        }
        if (a.e != null) {
            a.e.a = false;
        }
    };
    HighDensityScatterSeries.prototype.c7 = function (a) {
        var b = this.bs != null ? this.bs.mn : Rect.empty;
        var c = this.bs != null ? this.bs.m0 : Rect.empty;
        var d = new Rect(0, 0, 0, 1, 1);
        var e = this.lj(this.bi);
        var f = new ScalerParams(0, d, d, this.ly.b8, e);
        var g = new ScalerParams(0, d, d, this.l0.b8, e);
        var h = !b.isEmpty && !c.isEmpty && this.bz != null ? this.bz.indexOf(a) : -1;
        var i = this.ly != null && this.l5 != null && h < this.l5.count ? this.ly.dt(this.l5.item(h), f) : NaN;
        var j = this.l0 != null && this.l7 != null && h < this.l7.count ? this.l0.dt(this.l7.item(h), g) : NaN;
        if (!isNaN_(i)) {
            if (i < b.left + 0.1 * b.width) {
                i = i + 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
            if (i > b.right - 0.1 * b.width) {
                i = i - 0.4 * b.width;
                b.x = i - 0.5 * b.width;
            }
        }
        if (!isNaN_(j)) {
            if (j < b.top + 0.1 * b.height) {
                j = j + 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
            if (j > b.bottom - 0.1 * b.height) {
                j = j - 0.4 * b.height;
                b.y = j - 0.5 * b.height;
            }
        }
        if (this.bn != null) {
            this.bn.ap(this.bs, b, true);
        }
        return h >= 0;
    };
    HighDensityScatterSeries.prototype.ob = function (a, b, c, d) {
        var e = this.nh(b);
        var f = a.c;
        var g = this.nc;
        if (c) {
            var h = d.d;
            var i = d.b;
            var j = d.e;
            var k = d.c;
            if (this.l9) {
                h = this.mh + this.mj * h;
                i = this.mh + this.mj * i;
                j = this.mi + this.mg * j;
                k = this.mi + this.mg * k;
            }
            var l = truncate((this.mx + this.mz * (h - this.m1) / this.m3));
            var m = truncate((this.mx + this.mz * (i - this.m1) / this.m3));
            var n = truncate((this.my + this.mw * (j - this.m2) / this.m0));
            var o = truncate((this.my + this.mw * (k - this.m2) / this.m0));
            l = truncate(Math.floor(l));
            m = truncate(Math.floor(m));
            n = truncate(Math.floor(n));
            o = truncate(Math.floor(o));
            if (this.l8) {
                l -= g;
                m += g;
                n -= g;
                o += g;
            }
            var p = ((m - l) + 1) * ((o - n) + 1);
            var q = b / p;
            var r = q;
            for (var s = l; s <= m; s++) {
                for (var t = n; t <= o; t++) {
                    this.oa(f, s, t, q, r);
                }
            }
        }
        else {
            var u = a.a;
            var v = a.b;
            if (this.l9) {
                u = this.mh + this.mj * u;
                v = this.mi + this.mg * v;
            }
            var w = truncate((this.mx + this.mz * (u - this.m1) / this.m3));
            var x = truncate((this.my + this.mw * (v - this.m2) / this.m0));
            w = truncate(Math.floor(w));
            x = truncate(Math.floor(x));
            if (this.l8) {
                var y = w - g;
                var z = w + g;
                var aa = x + g;
                var ab = x - g;
                var ac = ((z - y) + 1) * ((aa - ab) + 1);
                var ad = b / ac;
                var ae = ad;
                for (var af = y; af <= z; af++) {
                    for (var ag = ab; ag <= aa; ag++) {
                        this.oa(f, af, ag, ad, ae);
                    }
                }
            }
            else {
                this.oa(f, w, x, b, 1);
            }
        }
    };
    HighDensityScatterSeries.prototype.ng = function (a, b) {
        return truncate((Math.floor(255 * b))) << 24 | truncate(Math.floor(b * (this.ms + a * this.mv))) << 16 | truncate(Math.floor(b * (this.mr + a * this.mu))) << 8 | truncate(Math.floor(b * (this.mq + a * this.mt)));
    };
    HighDensityScatterSeries.prototype.nh = function (a) {
        return 255 << 24 | truncate(Math.floor((this.ms + a * this.mv))) << 16 | truncate(Math.floor((this.mr + a * this.mu))) << 8 | truncate(Math.floor((this.mq + a * this.mt)));
    };
    HighDensityScatterSeries.prototype.m4 = function (a) {
        return (a >> 24 & 255) / 255;
    };
    HighDensityScatterSeries.prototype.oa = function (a, b, c, d, e) {
        if (b < 0 || b >= this.nb || c < 0 || c >= this.na) {
            return;
        }
        var f = (c * this.nb) + b;
        this.lu[f] = this.lu[f] + d;
        this.lr[f] = this.lr[f] + e;
        if (this.ma) {
            this._itemIndexes[f] = a + 1;
        }
        this.ne += truncate(d);
    };
    HighDensityScatterSeries.prototype.n8 = function () {
        var a = 0;
        var b = 0;
        var c = this.mm;
        var d = this.ml;
        var e = this.mk;
        var f = this.lu.length;
        var g = this.lu;
        var h = this.lr;
        var i = this.lt;
        var j = NaN;
        var k = NaN;
        var l = 0;
        var m = 0;
        for (var n = 0; n < f; n++) {
            a = g[n];
            if (a != 0) {
                b = h[n];
                if (a >= e) {
                    a = 1;
                }
                else if (a <= d) {
                    a = 0;
                }
                else {
                    a = (a - d) / (c);
                }
                if (b > 1) {
                    b = 1;
                }
                if (b < 0.2) {
                    b = 0.2;
                }
                if (j != a || k != b) {
                    l = this.ng(a, b);
                    j = a;
                    k = b;
                }
                i[m] = l >> 16 & 255;
                i[m + 1] = l >> 8 & 255;
                i[m + 2] = l & 255;
                i[m + 3] = l >> 24 & 255;
            }
            m += 4;
        }
    };
    HighDensityScatterSeries.prototype.n1 = function (a) {
        var b = a;
        b.b3();
    };
    HighDensityScatterSeries.prototype.bf = function () {
        return new HighDensityScatterSeriesView(this);
    };
    HighDensityScatterSeries.prototype.il = function (a) {
        _super.prototype.il.call(this, a);
        this.lv = a;
    };
    HighDensityScatterSeries.prototype.an = function (a) {
        if (a != null && a == this.ly && this.l5 != null) {
            return new AxisRange(this.l5.minimum, this.l5.maximum);
        }
        if (a != null && a == this.l0 && this.l7 != null) {
            return new AxisRange(this.l7.minimum, this.l7.maximum);
        }
        return null;
    };
    HighDensityScatterSeries.prototype.jj = function (a, b) {
        if (this.bs != null) {
            var c = this.getEffectiveViewport1(this.bi);
            this.l9 = !c.isEmpty;
        }
        this.i4(false);
    };
    HighDensityScatterSeries.prototype.jk = function (a, b) {
        this.i4(false);
    };
    HighDensityScatterSeries.prototype.fl = function (a) {
        if (!this.ma || this._itemIndexes == null || this.bs == null || this.bz == null || this._itemIndexes.length != (this.nb * this.na)) {
            return null;
        }
        var b = this.bs.mn;
        var c = (a.x - b.left) / b.width;
        var d = (a.y - b.top) / b.height;
        var e = truncate(Math.round(this.lp.left + (this.lp.width * c)));
        var f = truncate(Math.round(this.lp.top + (this.lp.height * d)));
        var g = this.nk(e, f);
        if (g < 0 || g > this._itemIndexes.length - 1) {
            return null;
        }
        var h = this._itemIndexes[g] - 1;
        if (h < 0 || h > this.bz.count) {
            return null;
        }
        return this.bz.item(h);
    };
    HighDensityScatterSeries.prototype.nk = function (a, b) {
        var c = (this.nb * b) + a;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        var d = 1;
        c = (this.nb * (b - d)) + a;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nb * (b + d)) + a;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nb * (b)) + a - 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nb * (b)) + a + 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nb * (b - d)) + a - 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nb * (b + d)) + a + 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nb * (b - d)) + a + 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        c = (this.nb * (b + d)) + a - 1;
        if (c > 0 && c < this._itemIndexes.length && this._itemIndexes[c] > 0) {
            return c;
        }
        return 0;
    };
    HighDensityScatterSeries.prototype.od = function (a, b, c) {
        this.lt = a;
        this.nb = b;
        this.na = c;
    };
    HighDensityScatterSeries.prototype.get_dn = function () {
        return true;
    };
    HighDensityScatterSeries.prototype.set_dn = function (a) {
        _super.prototype.set_dn.call(this, a);
    };
    HighDensityScatterSeries.prototype.ho = function (a, b) {
        _super.prototype.ho.call(this, a, b);
        this.lv.b4();
        if (this.bh != null) {
            this.bh.b4();
        }
        this.ib();
    };
    HighDensityScatterSeries.prototype.i6 = function (a, b) {
        _super.prototype.i6.call(this, a, b);
        if (!this.dj) {
            this.bi.az(b);
            return;
        }
        this.bi.az(b);
        if (this.cc(this.bh)) {
            return;
        }
        var c = typeCast(HighDensityScatterSeriesView.$, this.bh);
        var d = new ScatterFrame();
        this.n5(false, c);
        this.dj = false;
    };
    HighDensityScatterSeries.prototype.i3 = function (a, b, c, d, e) {
        _super.prototype.i3.call(this, a, b, c, d, e);
        var f = this.a0.a$h.item(d);
        var g = f;
        f.ay(c);
        if (this.cc(g)) {
            return;
        }
        if (this.l3 == null) {
            this.l3 = new ScatterFrame();
        }
        this.n5(false, f);
    };
    HighDensityScatterSeries.prototype.hm = function () {
        _super.prototype.hm.call(this);
        this.ly = null;
        this.l0 = null;
    };
    HighDensityScatterSeries.$t = markType(HighDensityScatterSeries, 'HighDensityScatterSeries', Series.$);
    return HighDensityScatterSeries;
}(Series));
export { HighDensityScatterSeries };
Type.dep(DependencyProperty, PropertyMetadata, HighDensityScatterSeries, 'raisePropertyChanged', ['HeatMaximumColor:oq:of', [Color.$, null], 'HeatMaximum:m5:og', [1, 50], 'HeatMinimumColor:or:oh', [Color.$, null], 'HeatMinimum:m6:oi', [1, 0], 'PointExtent:ni:oj', [1, 1], 'ProgressiveLoad:md:ok', [0, true], 'UseBruteForce:me:ol', [0, false], 'XAxis:ly:om', [NumericXAxis.$, null], 'XMemberPath:nu:on', [2, null], 'YAxis:l0:oo', [NumericYAxis.$, null], 'YMemberPath:ny:op', [2, null]]);
var HighDensityScatterSeriesView = /** @class */ (function (_super) {
    tslib_1.__extends(HighDensityScatterSeriesView, _super);
    function HighDensityScatterSeriesView(a) {
        var _this = _super.call(this, a) || this;
        _this.bw = null;
        _this.bu = null;
        _this.b2 = 0;
        _this.b1 = 0;
        _this.bz = null;
        _this.b0 = null;
        _this.bx = null;
        _this.bw = a;
        return _this;
    }
    HighDensityScatterSeriesView.prototype.ap = function () {
        _super.prototype.ap.call(this);
        if (!this.n) {
            this.e.eq = 4;
            this.bw.or = Color.u(255, 0, 0, 0);
            this.bw.oq = Color.u(255, 255, 0, 0);
        }
    };
    HighDensityScatterSeriesView.prototype.b7 = function () {
        this.bw.od(this.bu, this.b2, this.b1);
    };
    HighDensityScatterSeriesView.prototype.b3 = function () {
        if (this.bz == null) {
            this.bz = this.e.e0.createElement("canvas");
            var a = this.e.e0.get2DCanvasContext(this.bz);
            this.bx = new RenderingContext(new CanvasViewRenderer(), a);
        }
        var b;
        if (this.m) {
            b = this.br;
        }
        else {
            b = this.e.bs.ms();
        }
        var c = truncate(Math.round(b.left));
        var d = truncate(Math.round(b.top));
        var e = truncate(Math.round(b.width));
        var f = truncate(Math.round(b.height));
        var g = this.b2;
        var h = this.b1;
        this.b2 = e;
        this.b1 = f;
        if (g != this.b2 || h != this.b1 || this.bu == null) {
            this.bz.setAttribute("width", e.toString());
            this.bz.setAttribute("height", f.toString());
            this.b0 = this.bx.g().getImageData(0, 0, e, f);
            var imageDataArray_ = this.b0.data;
            this.bu = imageDataArray_;
        }
        this.bw.od(this.bu, this.b2, this.b1);
    };
    HighDensityScatterSeriesView.prototype.bv = function () {
        return this.bu;
    };
    HighDensityScatterSeriesView.prototype.b6 = function () {
        var a = truncate(Math.round(this.br.left));
        var b = truncate(Math.round(this.br.left));
        var c = truncate(Math.round(this.br.width));
        var d = truncate(Math.round(this.br.height));
        this.bx.g().putImageData(this.b0, 0, 0);
        this.an();
    };
    HighDensityScatterSeriesView.prototype.b5 = function (a) {
        if (this.e.e0 != null) {
            this.e.e0.setTimeout(a, 0);
        }
        else {
            window.setTimeout(a, 0);
        }
    };
    HighDensityScatterSeriesView.prototype.a3 = function (a, b) {
        _super.prototype.a3.call(this, a, b);
        if (b) {
            if (!this.bw.c5) {
                return;
            }
            var c = new Rectangle();
            c.n = this.br.left;
            c.o = this.br.top;
            c.width = this.br.width;
            c.height = this.br.height;
            c._fill = this.bl();
            a.v(c);
            return;
        }
        if (this.bz == null) {
            return;
        }
        var d = truncate(Math.round(this.br.left));
        var e = truncate(Math.round(this.br.top));
        var f = truncate(Math.round(this.br.width));
        var g = truncate(Math.round(this.br.height));
        this.h.n(this.bz.getNativeElement(), this.e._opacity, d, e, f, g, d, e, f, g);
    };
    HighDensityScatterSeriesView.prototype.by = function (a, b) {
        return Color.e(Nullable$1.toNullable(Color.$, a), Nullable$1.toNullable(Color.$, null)) && Color.e(Nullable$1.toNullable(Color.$, b), Nullable$1.toNullable(Color.$, null));
    };
    HighDensityScatterSeriesView.prototype.b4 = function () {
        if (this.bu != null) {
            for (var a = 0; a < this.bu.length; a++) {
                this.bu[a] = 0;
            }
            this.b6();
        }
    };
    HighDensityScatterSeriesView.prototype.ai = function (a) {
        _super.prototype.ai.call(this, a);
        if (this.bu == null) {
            this.e.a2.exportSeriesPixelsData(a, null, this.b2, this.b1);
            return;
        }
        var b = new Array(intDivide(this.bu.length, 4));
        var c;
        for (var d = 0; d < intDivide(this.bu.length, 4); d++) {
            c = d * 4;
            b[d] = this.bu[c + 3] << 24 | this.bu[c] << 16 | this.bu[c + 1] << 8 | this.bu[c + 2];
        }
        this.e.a2.exportSeriesPixelsData(a, b, this.b2, this.b1);
    };
    HighDensityScatterSeriesView.$t = markType(HighDensityScatterSeriesView, 'HighDensityScatterSeriesView', SeriesView.$);
    return HighDensityScatterSeriesView;
}(SeriesView));
export { HighDensityScatterSeriesView };
